import { routes } from '@/router'
const state = {
  topModuleList: JSON.parse(sessionStorage.getItem('topModuleList')),
  leftMenuList: JSON.parse(sessionStorage.getItem('leftMenuList')),
  activeModule: sessionStorage.getItem('activeModule'), // 顶部菜单模块
  activeMenu: sessionStorage.getItem('activeMenu') // 左侧菜单
}

const mutations = {
  SET_TOPMODULE: (state, menuModule) => {
    state.topModuleList = menuModule
    sessionStorage.setItem('topModuleList', JSON.stringify(menuModule))
  },
  SET_LEFTMENU: (state, menu) => {
    state.leftMenuList = menu
    sessionStorage.setItem('leftMenuList', JSON.stringify(menu))
  },
  SET_ACTIVEMODULE: (state, activeModule) => {
    state.activeModule = activeModule
    sessionStorage.setItem('activeModule', activeModule)
  },
  SET_ACTIVEMENU: (state, activeMenu) => {
    state.activeMenu = activeMenu || state.leftMenuList[0].name
    sessionStorage.setItem('activeMenu', state.activeMenu)
  }
}

const actions = {
  // 获取顶部菜单模块
  getTopModuleList({ commit }) {
    let temp = []
    routes &&
      routes.map((item) => {
        if (item.hidden) {
          return true
        }
        let obj = {}
        obj.name = item.name
        obj.label = item.meta.title
        temp.push(obj)
      })
    commit('SET_TOPMODULE', temp)
  },
  // 设置菜单模块
  setActiveModule({ commit, dispatch }, activeBox) {
    const { activeModule, activeMenu } = activeBox
    if (activeModule === 'home') {
      commit('SET_LEFTMENU', [])
    } else {
      dispatch('getLeftMenuList', activeModule)
      dispatch('setActiveMenu', activeMenu)
    }
    commit('SET_ACTIVEMODULE', activeModule)
  },
  // 获取左侧菜单
  getLeftMenuList({ commit }, menuName) {
    let temp = []
    for (let i = 0; i < routes.length; i++) {
      if (menuName === routes[i].name) {
        temp = routes[i].children
      }
    }
    commit('SET_LEFTMENU', temp)
  },
  setActiveMenu({ commit }, activeMenu) {
    commit('SET_ACTIVEMENU', activeMenu)
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
